#ifndef WORLD_H
#define WORLD_H

#include "common/BlockStorage.h"
#include "common/entities/Entity.h"
#include "utils/List.h"

class World final {
    List<Entity*> entities;

public:
    BlockStorage blocks;

    World();

    void addEntity(Entity* e);
    void removeEntity(Entity* e);

    void tick();

    Vector3 limitMove(const Entity& e, Vector3 move) const;

private:
    List<Box> getBoxes(const Box& box) const;
};

#endif